////////////////////////////////////////////////////////////////////////////////
// FileSearch.h : Declaration of the FileSearch
//
// Updated: 15th June 2006

#ifndef __FILESEARCH_H_
#define __FILESEARCH_H_

#include "resource.h"       // main symbols

////////////////////////////////////////////////////////////////////////////////
// FileSearch

class ATL_NO_VTABLE FileSearch
    : public CComObjectRootEx<CComMultiThreadModelNoCS>
    , public CComCoClass<FileSearch, &CLSID_FileSearch>
    , public IDispatchImpl<IFileSearch3, &IID_IFileSearch3, &LIBID_RECLS_COMLib>
    , public IDispatchImpl<IFtpSearch, &IID_IFtpSearch, &LIBID_RECLS_COMLib>
    , public atlstl::SupportErrorInfoImpl4<&IID_IFileSearch, &IID_IFileSearch2, &IID_IFileSearch3, &IID_IFtpSearch>
{
public:
    FileSearch();
    ~FileSearch() stlsoft_throw_0();

DECLARE_REGISTRY_RESOURCEID(IDR_FILESEARCH)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(FileSearch)
//  COM_INTERFACE_ENTRY(IFileSearch4)
    COM_INTERFACE_ENTRY(IFileSearch3)
    COM_INTERFACE_ENTRY(IFileSearch2)
    COM_INTERFACE_ENTRY(IFileSearch)
    COM_INTERFACE_ENTRY(IFtpSearch)
    COM_INTERFACE_ENTRY2(IDispatch, IFileSearch)
    COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// IFileSearch
private:
    STDMETHOD(get_WildcardsAll)(/*[out, retval]*/ BSTR *pVal);
    STDMETHOD(get_PathSeparator)(/*[out, retval]*/ BSTR *pVal);
    STDMETHOD(get_PathNameSeparator)(/*[out, retval]*/ BSTR *pVal);
    STDMETHOD(Search)(/*[in]*/ BSTR searchRoot, /*[in]*/ BSTR pattern, /*[in]*/ long flags, /*[out, retval]*/ IUnknown **ppenum);
    STDMETHOD(get_Roots)(/* [out, retval] */ LPUNKNOWN *pVal);

// IFileSearch2
private:
    STDMETHOD(SearchProgress)(/*[in]*/ BSTR searchRoot, /*[in]*/ BSTR pattern, /*[in]*/ long flags, /*[in]*/ LPUNKNOWN punkProgress, /*[out, retval]*/ IUnknown **ppenum);

// IFileSearch3
private:
    STDMETHOD(get_SelectedRoots)(/*[in]*/ DWORD flags, /*[out,retval]*/ LPUNKNOWN *selectedRoots);
    STDMETHOD(CombinePaths)(/* [in, string] */ BSTR path1, /* [in, string] */ BSTR path2, /* [out, retval] */ BSTR *result);
    STDMETHOD(DeriveRelativePath)(/* [in, string] */ BSTR origin, /* [in, string] */ BSTR target, /* [out, retval] */ BSTR *result);
    STDMETHOD(SqueezePath)(/* [in, string] */ BSTR path, /* [in] */ long width, /* [out, retval] */ BSTR *result);

// IFileSearch4
private:

// IFtpSearch
private:
    STDMETHOD(Search)(/*[in]*/ BSTR host, /*[in]*/ BSTR username, /*[in]*/ BSTR password, /*[in]*/ BSTR searchRoot, /*[in]*/ BSTR pattern, /*[in]*/ long flags, /*[out, retval]*/ IUnknown **ppenum);

// Implementation
private:
    HRESULT get_Roots_(recls_root_t roots[], size_t cRoots, LPUNKNOWN *pVal);
    HRESULT CombinePaths_(recls_char_t const *path1, recls_char_t const *path2, BSTR &result);
    HRESULT DeriveRelativePath_(recls_char_t const *origin, recls_char_t const *target, BSTR &result);
    HRESULT SqueezePath_(recls_char_t const *path, size_t width, BSTR &result);
};

////////////////////////////////////////////////////////////////////////////////

#endif //__FILESEARCH_H_

////////////////////////////////////////////////////////////////////////////////
