////////////////////////////////////////////////////////////////////////////////
// SearchFlags.cpp : Implementation of SearchFlags
//
// Created: 19th March 2006
// Updated: 19th March 2006
//

#include "stdafx.h"
#include "recls.com.h"
#include "SearchFlags.h"

/////////////////////////////////////////////////////////////////////////////
// SearchFlags

////////////////////////////////////////////////////////////////////////////////
// ISearchFlags

#if 0
    STDMETHOD(get_Files)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_Directories)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_Links)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_Devices)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_TypeMask)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_Recursive)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_NoFollowLinks)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_DirectoryParts)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_DetailsLater)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_MarkDirectories)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_AllowReparseDirectories)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_UseTildeOnNoSearchRoot)(/*[out, retval]*/ long *pVal);
#endif /* 0 */

STDMETHODIMP SearchFlags::get_Files(/*[out, retval]*/ long *pVal)
{
    return (NULL == pVal) ? E_POINTER : (*pVal = RECLS_F_FILES, S_OK);
}

#define SearchFlags_Method_Def(name, flag)                              \
                                                                        \
    STDMETHODIMP SearchFlags::get_##name(/*[out, retval]*/ long *pVal)  \
    {                                                                   \
        return (NULL == pVal) ? E_POINTER : (*pVal = flag, S_OK);       \
    }

SearchFlags_Method_Def(Directories, RECLS_F_DIRECTORIES)
SearchFlags_Method_Def(Links, RECLS_F_LINKS)
SearchFlags_Method_Def(Devices, RECLS_F_DEVICES)
SearchFlags_Method_Def(TypeMask, RECLS_F_TYPEMASK)
SearchFlags_Method_Def(Recursive, RECLS_F_RECURSIVE)
SearchFlags_Method_Def(NoFollowLinks, RECLS_F_NO_FOLLOW_LINKS)
SearchFlags_Method_Def(DirectoryParts, RECLS_F_DIRECTORY_PARTS)
SearchFlags_Method_Def(DetailsLater, RECLS_F_DETAILS_LATER)
SearchFlags_Method_Def(PassiveFTP, RECLS_F_PASSIVE_FTP)
SearchFlags_Method_Def(MarkDirectories, RECLS_F_MARK_DIRS)
SearchFlags_Method_Def(AllowReparseDirectories, RECLS_F_ALLOW_REPARSE_DIRS)
SearchFlags_Method_Def(UseTildeOnNoSearchRoot, RECLS_F_USE_TILDE_ON_NO_SEARCHROOT)


////////////////////////////////////////////////////////////////////////////////











