////////////////////////////////////////////////////////////////////////////////
// SearchFlags.h : Declaration of the SearchFlags class
//
// Updated: 19th March 2006

#ifndef __SEARCHFLAGS_H_
#define __SEARCHFLAGS_H_

#include "resource.h"       // main symbols

////////////////////////////////////////////////////////////////////////////////
// SearchFlags

class ATL_NO_VTABLE SearchFlags
    : public CComObjectRootEx<CComMultiThreadModelNoCS>
    , public CComCoClass<SearchFlags, &CLSID_SearchFlags>
    , public IDispatchImpl<ISearchFlags, &IID_ISearchFlags, &LIBID_RECLS_COMLib>
    , public atlstl::SupportErrorInfoImpl<&IID_ISearchFlags>
{
public:

DECLARE_REGISTRY_RESOURCEID(IDR_SEARCHFLAGS)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(SearchFlags)
    COM_INTERFACE_ENTRY(ISearchFlags)
    COM_INTERFACE_ENTRY(IDispatch)
    COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISearchFlags
public:
    STDMETHOD(get_Files)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_Directories)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_Links)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_Devices)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_TypeMask)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_Recursive)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_NoFollowLinks)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_DirectoryParts)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_DetailsLater)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_PassiveFTP)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_MarkDirectories)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_AllowReparseDirectories)(/*[out, retval]*/ long *pVal);
    STDMETHOD(get_UseTildeOnNoSearchRoot)(/*[out, retval]*/ long *pVal);
};

////////////////////////////////////////////////////////////////////////////////

#endif //__SEARCHFLAGS_H_

////////////////////////////////////////////////////////////////////////////////
