
import recls
import string
from sys import exit
import time

def dumpEntry(entry_):
	print "Path:                  " + entry_.path
	print "Search Directory:      " + entry_.searchDirectory
	print "Search-Relative Path:  " + entry_.searchRelativePath
	print "UNC Drive:             " + entry_.uncDrive
	print "Directory:             " + entry_.directory
	print "DirectoryPath:         " + entry_.directoryPath
	print "Drive:                 " + entry_.drive
	parts 		= 	entry_.directoryParts
	lenDrive	=	len(entry_.drive)
	lenUNCDrive	=	len(entry_.uncDrive)
	if 0 != lenUNCDrive:
		off = lenUNCDrive
	elif 0 != lenDrive:
		off = 2
	else:
		off = 0
	print "len(drive):    " + str(lenDrive)
	print "len(uncDrive): " + str(lenUNCDrive)
	if parts:
		print "DirectoryParts:"
		for part in parts:
			print "                     ",
			print string.rjust("", off),
			print part
			off = off + len(part)
	print "Size:                  " + str(entry_.size)
	print "File:                  " + entry_.file
	print "ShortFile:             " + entry_.shortFile
	print "FileName:              " + entry_.fileName
	print "FileExt:               " + entry_.fileExt
	print "Creation Time:         " + time.strftime("%d %b %Y %H:%M:%S", time.gmtime(entry_.creationTime))
	print "Modification Time:     " + time.strftime("%d %b %Y %H:%M:%S", time.gmtime(entry_.modificationTime))
	print "LastAccess Time:       " + time.strftime("%d %b %Y %H:%M:%S", time.gmtime(entry_.lastAccessTime))
	print "LastStatusChange Time: " + time.strftime("%d %b %Y %H:%M:%S", time.gmtime(entry_.lastStatusChangeTime))

# end dumpEntry()


print "recls version:        " + recls.__recls_version__
print "recls/Python version: " + recls.__version__


print "result: " + recls.combinePaths("abc", "def")
print "result: " + recls.combinePaths("abc", "/def")

print "~: " + recls.stat(".").path

print recls.squeezePath(recls.stat(".").path, 160)

print recls.deriveRelativePath("/usr/include/recls", "/usr/lib/recls")

print "Roots:"
for root in recls.roots():
		print "  " + root

print "Selected roots:"
for root in recls.selectedRoots(recls.FIXED_DRIVES):
		print "  " + root

print "Selected roots:"
for root in recls.selectedRoots(recls.NETWORK_DRIVES):
		print "  " + root

#exit(0)

#dumpEntry(recls.stat("ftp:x"))

rootDir	=	"."
pattern	=	"*.*"
#rootDir	=	"X:\\"
#rootDir	=	"/freelibs/recls"
#pattern	=	"*.pdf"

print 'Searching: "' + rootDir + '" for "' + pattern + '"'

srch = recls.filesearch(rootDir, pattern, recls.DIRECTORY_PARTS | recls.FILES | recls.RECURSIVE)

print "Search::rootDir:  " + srch.rootDir
print "Search::pattern:  " + srch.pattern
print "Search::flags:    " + hex(srch.flags)

#print "Search:    " + str(srch)

#print "Search::items():  " + str(srch.items())

for entry in srch.items():
#	print "Item: " + entry.path
	dumpEntry(entry)
	print ""

print
print
print

exit(0)

srch = recls.ftpsearch("ftp.digitalmars.com", "anonymous", "a@b.c", "/", "*.zip", recls.DIRECTORY_PARTS | recls.FILES | recls.RECURSIVE)
for entry in srch.items():
#	print "Item: " + entry.path
	dumpEntry(entry)
	print ""



