/* /////////////////////////////////////////////////////////////////////////////
 * File:        sample_directories_Cpp.cpp
 *
 * Purpose:     Implementation file for the sample_directories_Cpp project.
 *
 * Created:     20th September 2005
 * Updated:     17th December 2005
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (c) 2005, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              This source code is placed into the public domain 2005
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software. 
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage. 
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission. 
 *
 * ////////////////////////////////////////////////////////////////////////// */


/* recls Header Files */
#include <recls/cpp/filesearch.hpp>
#ifndef RECLS_NO_IMPLICIT_LINK
# include <recls/implicit_link.h>
#endif /* !RECLS_NO_IMPLICIT_LINK */

/* Standard C++ Header Files */
#include <exception>
#include <iostream>
#include <string>

using std::cerr;
using std::cin;
using std::cout;
using std::endl;

#ifdef __WATCOMC__
namespace std
{
    using ::exception;
}
#endif /* __WATCOMC__ */

/* Standard C Header Files */

/* ////////////////////////////////////////////////////////////////////////// */

static int main_(int /* argc */, char ** /*argv*/)
{
    cout << "Listing the sub-directories of the current directory:" << endl;

    reclspp::FileSearch fs(".", recls::Recls_GetWildcardsAll(), recls::RECLS_F_DIRECTORIES | recls::RECLS_F_RECURSIVE);
    int                 n;

    for(n = 0; fs.HasMoreElements(); ++n, fs.GetNext())
    {
        reclspp::FileEntry  fe  =   fs.GetCurrentEntry();

        cout << "  " << fe.GetPath() << endl;
    }

    cout << "    " << n << " directories" << endl;

    return 0;
}

int main(int argc, char *argv[])
{
    try
    {
        return main_(argc, argv);
    }
    catch(reclspp::ReclsException &x)
    {
        fprintf(stderr, "Search failed: %s\n", x.what());
    }
    catch(std::exception &x)
    {
        fprintf(stderr, "Unhandled error: %s\n", x.what());
    }
    catch(...)
    {
        fprintf(stderr, "Unhandled unknown error\n");
    }

    return EXIT_FAILURE;
}

/* ////////////////////////////////////////////////////////////////////////// */
