/* /////////////////////////////////////////////////////////////////////////////
 * File:        recls_util.h
 *
 * Purpose:     Implementation header.
 *
 * Created:     17th August 2003
 * Updated:     17th June 2006
 *
 * Home:        http://recls.org/
 *
 * Copyright (c) 2003-2006, Matthew Wilson and Synesis Software
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted in accordance with the license and warranty
 * information described in recls.h (included in this distribution, or available
 * from http://recls.org/)
 *
 * ////////////////////////////////////////////////////////////////////////// */


#ifndef RECLS_INCL_H_RECLS_UTIL
#define RECLS_INCL_H_RECLS_UTIL

/* /////////////////////////////////////////////////////////////////////////////
 * Includes
 */

#include <recls/recls.h>

/* /////////////////////////////////////////////////////////////////////////////
 * Namespace
 */

#if !defined(RECLS_NO_NAMESPACE)
namespace recls
{
#endif /* !RECLS_NO_NAMESPACE */

/* /////////////////////////////////////////////////////////////////////////////
 * Functions
 */

RECLS_LINKAGE_C recls_bool_t        is_dots(recls_char_t const *f);

RECLS_LINKAGE_C size_t              align_up_size(size_t i);

RECLS_LINKAGE_C size_t              count_char_instances(recls_char_t const *begin, recls_char_t const *end, recls_char_t const ch);

RECLS_LINKAGE_C size_t              recls_strncpy(recls_char_t *dest, size_t cchDest, recls_char_t const *src, size_t cchSrc);
RECLS_LINKAGE_C size_t              recls_strlen(recls_char_t const *dest);

RECLS_LINKAGE_C recls_char_t const  *find_directory_0(recls_char_t const *path);

RECLS_FNDECL(size_t)                Recls_GetStringProperty_(   struct recls_strptrs_t const    *ptrs
                                                            ,   recls_char_t                    *buffer
                                                            ,   size_t                          cchBuffer);

RECLS_FNDECL(recls_rc_t)            IsValidPattern( recls_char_t const  *pattern
                                                ,   recls_uint32_t      flags
                                                ,   size_t              maxPathCompLen);

RECLS_LINKAGE_C recls_bool_t        is_home_start_(recls_char_t const *path);

RECLS_LINKAGE_C size_t              get_home_(recls_char_t *buff, size_t cchBuff);

/* /////////////////////////////////////////////////////////////////////////////
 * Namespace
 */

#if !defined(RECLS_NO_NAMESPACE)
} /* namespace recls */
#endif /* !RECLS_NO_NAMESPACE */

/* ////////////////////////////////////////////////////////////////////////// */

#endif /* !RECLS_INCL_H_RECLS_UTIL */

/* ////////////////////////////////////////////////////////////////////////// */
