/* /////////////////////////////////////////////////////////////////////////
 * File:        test_cpp_2.cpp
 *
 * Purpose:     Implementation file for the test_cpp_2 project.
 *
 * Created:     26th February 2007
 * Updated:     27th February 2007
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (c) 2007-2007, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 * ////////////////////////////////////////////////////////////////////// */


/* recls Header Files */
#include <recls/cpp/filesearch.hpp>



/* STLSoft Header Files */
#include <stlsoft/stlsoft.h>

/* PlatformSTL Header Files */
#include <platformstl/platformstl.hpp>


/* Standard C++ Header Files */
#include <exception>
#include <iostream>
#if 0
#include <algorithm>
#include <iterator>
#include <list>
#include <string>
#include <vector>
#endif /* 0 */

#if !defined(__WATCOMC__) && \
    (   !defined(_MSC_VER) || \
        _MSC_VER >= 1100)

#else /* ? __WATCOMC__ */
namespace std
{
    using ::exception;
}
#endif /* __WATCOMC__ */

/* Standard C Header Files */
#include <stdio.h>
#include <stdlib.h>

#if defined(_MSC_VER) && \
    defined(_DEBUG)
# include <crtdbg.h>
#endif /* _MSC_VER) && _DEBUG */

/* /////////////////////////////////////////////////////////////////////////
 * Macros and definitions
 */


/* /////////////////////////////////////////////////////////////////////////
 * Globals
 */


/* /////////////////////////////////////////////////////////////////////////
 * Typedefs
 */

#if 0
typedef std::string     string_t;
#endif /* 0 */

/* /////////////////////////////////////////////////////////////////////////
 * Forward declarations
 */

RECLS_FNDECL(void) Recls_RunUnittests(FILE *stm);

/* ////////////////////////////////////////////////////////////////////// */

static int main_(int /* argc */, char ** /*argv*/)
{
	if(1)
	{
		recls::cpp::FileSearch	srch(NULL, NULL, recls::FILES | recls::RECURSIVE);

		for(; srch.HasMoreElements(); srch.GetNext())
		{
			recls::cpp::FileEntry	entry		=	srch.GetCurrentEntry();
			recls::cpp::string_t	path		=	entry.GetPath();
			recls::cpp::string_t	searchDir	=	entry.GetSearchDirectory();
			recls::cpp::string_t	searchRel	=	entry.GetSearchRelativePath();
			recls::cpp::string_t	combined	=	recls::cpp::FileSearch::CombinePaths(searchDir, searchRel);

			std::cout << searchDir << std::endl;
			std::cout << searchRel << std::endl;
			std::cout << path << std::endl;
			std::cout << combined << std::endl;
			std::cout << std::endl;

			RECLS_ASSERT(path == combined);

			std::replace(path.begin(), path.end(), '\\', '/');

			recls::cpp::FileSearch::Stat(path);
		}
	}

	if(1)
	{
		recls::cpp::FileSearch	srch("../../..", "*.dsw", recls::FILES | recls::RECURSIVE);

		for(; srch.HasMoreElements(); srch.GetNext())
		{
			recls::cpp::FileEntry	entry		=	srch.GetCurrentEntry();
			recls::cpp::string_t	path		=	entry.GetPath();
			recls::cpp::string_t	searchDir	=	entry.GetSearchDirectory();
			recls::cpp::string_t	searchRel	=	entry.GetSearchRelativePath();
			recls::cpp::string_t	combined	=	recls::cpp::FileSearch::CombinePaths(searchDir, searchRel);

			std::cout << searchDir << std::endl;
			std::cout << searchRel << std::endl;
			std::cout << path << std::endl;
			std::cout << combined << std::endl;
			std::cout << std::endl;

			RECLS_ASSERT(path == combined);

			std::replace(path.begin(), path.end(), '\\', '/');

			recls::cpp::FileSearch::Stat(path);
		}
	}

	if(1)
	{
		recls::cpp::FileSearch	srch("H:\\freelibs\\vole\\current\\samples\\wordgrep\\vc6", "*.ds?|H:\\Publishing\\Books\\XSTL\\vol1\\drafting\\XSTL-monolithic.doc", recls::FILES /* | recls::RECURSIVE */);

		for(; srch.HasMoreElements(); srch.GetNext())
		{
			recls::cpp::FileEntry	entry		=	srch.GetCurrentEntry();
			recls::cpp::string_t	path		=	entry.GetPath();
			recls::cpp::string_t	searchDir	=	entry.GetSearchDirectory();
			recls::cpp::string_t	searchRel	=	entry.GetSearchRelativePath();
			recls::cpp::string_t	combined	=	recls::cpp::FileSearch::CombinePaths(searchDir, searchRel);

			std::cout << searchDir << std::endl;
			std::cout << searchRel << std::endl;
			std::cout << path << std::endl;
			std::cout << combined << std::endl;
			std::cout << std::endl;

			RECLS_ASSERT(path == combined);

			std::replace(path.begin(), path.end(), '\\', '/');

			recls::cpp::FileSearch::Stat(path);
		}
	}



	Recls_RunUnittests(stdout);

    return EXIT_SUCCESS;
}

int main(int argc, char *argv[])
{
    int             res;

#if defined(_MSC_VER) && \
    defined(_DEBUG)
    _CrtMemState    memState;
#endif /* _MSC_VER && _MSC_VER */

#if defined(_MSC_VER) && \
    defined(_DEBUG)
    _CrtMemCheckpoint(&memState);
#endif /* _MSC_VER && _MSC_VER */

#if 0
    { for(size_t i = 0; i < 0xffffffff; ++i){} }
#endif /* 0 */

    try
    {
#if defined(_DEBUG) || \
    defined(__SYNSOFT_DBS_DEBUG)
        puts("test_cpp_2: " __STLSOFT_COMPILER_LABEL_STRING);
#endif /* debug */

        res = main_(argc, argv);
    }
    catch(std::exception &x)
    {
        fprintf(stderr, "Unhandled error: %s\n", x.what());

        res = EXIT_FAILURE;
    }
    catch(...)
    {
        fprintf(stderr, "Unhandled unknown error\n");

        res = EXIT_FAILURE;
    }

#if defined(_MSC_VER) && \
    defined(_DEBUG)
    _CrtMemDumpAllObjectsSince(&memState);
#endif /* _MSC_VER) && _DEBUG */

    return res;
}

/* ////////////////////////////////////////////////////////////////////// */
