/* /////////////////////////////////////////////////////////////////////////
 * File:        recls_test.java
 *
 * Purpose:     Test file for the recls Java mapping.
 *
 * Created:     22nd November 2003
 * Updated:     16th June 2006
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (c) 1999-2006, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2003
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software. 
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage. 
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission. 
 *
 * ////////////////////////////////////////////////////////////////////// */


import org.recls.Entry;
import org.recls.ReclsException;
import org.recls.Search;
import org.recls.FileSearch;
import org.recls.FtpSearch;

import java.util.Enumeration;

public class recls_test
{
    public static void main(String[] args)
    {
        int     i;
        String  host        =   null;
        String  username    =   null;
        String  password    =   null;
        String  pattern     =   null;
        String  rootDir     =   null;
        int     flags       =   Search.RECLS_F_RECURSIVE;
        boolean bSuccinct   =   false;

		run_unittests();

/*
        for(i = 0; i < args.length; ++i)
        {
            String  arg = args[i];

            System.out.println(i + ": " + arg);
        }
        System.exit(0);
*/

        for(i = 0; i < args.length; ++i)
        {
            String  arg = args[i];

            if(arg.charAt(0) == '-')
            {
                if(arg.charAt(1) == '-')
                {
                    /* -- arguments */
                }
                else
                {
                    /* - arguments */
                    switch(arg.charAt(1))
                    {
                        case    'R':    /* Do not recurse */
                            flags &= ~(Search.RECLS_F_RECURSIVE);
                            break;
                        case    'p':    /* Show directory parts */
                            flags |= Search.RECLS_F_DIRECTORY_PARTS;
                            break;
                        case    'f':    /* Find files */
                            flags |= Search.RECLS_F_FILES;
                            break;
                        case    'd':    /* Find directories */
                            flags |= Search.RECLS_F_DIRECTORIES;
                            break;
                        case    's':    /* Show only the full path; WHEREIS functionality */
                            bSuccinct = true;
                            break;
                        case    'H':
                            host = arg.substring(2);
                            break;
                        default:
                            usage("Unrecognised argument: " + arg);
                            break;
                    }
                }
            }
            else
            {
                /* other arguments */
                if(null == pattern)
                {
                    pattern = arg;
                }
                else if(null == rootDir)
                {
                    rootDir = arg;
                }
                else
                {
                     usage("Unrecognised argument: " + arg);
                }
            }
        }

        /* Search for files if neither files or directories specified/
         *
         * Even though this is not necessary, because the recls API provides the
         * same interpretation, it's best to be explicit.
         */
        if(0 == (flags & (Search.RECLS_F_FILES | Search.RECLS_F_DIRECTORIES)))
        {
            flags |= Search.RECLS_F_FILES;
        }

        Entry local =   FileSearch.Stat(".", 0);

        System.out.println("Local dir: " + local.getPath());

        try
        {
            int     total   =   0;
            Search  search;

            if(null != host)
            {
                search  =   new FtpSearch(host, username, password, rootDir, pattern, flags);
            }
            else
            {
                search  =   new FileSearch(rootDir, pattern, flags);
            }

            for(Enumeration en = search; en.hasMoreElements(); ++total)
            {
                Object  el  =   en.nextElement();

                System.out.println(el);

                if(!bSuccinct)
                {
                    Entry   entry   =   (Entry)el;

                    System.out.println("  Path:                  " + entry.getPath());
                    System.out.println("  Drive:                 " + entry.getDrive());
                    System.out.println("  Directory:             " + entry.getDirectory());
                    System.out.println("  DirectoryPath:         " + entry.getDirectoryPath());
                    System.out.println("  UNCDrive:              " + entry.getUNCDrive());
                    if((flags & Search.RECLS_F_DIRECTORY_PARTS) == Search.RECLS_F_DIRECTORY_PARTS)
                    {
                        String[]    dirParts    =   entry.getDirectoryParts();
                        for(int j = 0; j < dirParts.length; ++j)
                        {
                            System.out.println("    " + dirParts[j]);
                        }
                    }
                    System.out.println("  File:                  " + entry.getFile());
                    System.out.println("  ShortFile:             " + entry.getShortFile());
                    System.out.println("  FileName:              " + entry.getFileName());
                    System.out.println("  FileExt:               " + entry.getFileExt());
                    System.out.println("  Size:                  " + entry.getSize());
                    System.out.println("  CreationTime:          " + entry.getCreationTime());
                    System.out.println("  ModificationTime:      " + entry.getModificationTime());
                    System.out.println("  LastAccessTime:        " + entry.getLastAccessTime());
                    System.out.println("  LastStatusChangeTime:  " + entry.getLastStatusChangeTime());
                    System.out.println("  isReadOnly:            " + entry.isReadOnly());
                    System.out.println("  isDirectory:           " + entry.isDirectory());
                    System.out.println("  isLink:                " + entry.isLink());
                    System.out.println("  isUNC:                 " + entry.isUNC());
                }
            }

            search.close();

            System.out.println("  Total matched: " + total);
        }
        catch(ReclsException x)
        {
            System.out.println(x);
        }
    }

    /** Displays program usage */
    private static void usage(String message)
    {
        System.err.println("recls Java Test Program: java_test\n");
        System.err.println("");
        if(message != null)
        {
            System.err.println("  Error: " + message);
            System.err.println("");
        }
        System.err.println("Usage: java java_test [-d] [-f] [-d] [-R] [-H<host>] [<pattern>] [<root-dir>]");
        System.err.println("\t-d               -   search for directories");
        System.err.println("\t-f               -   search for files. (default if neither f or d specified)");
        System.err.println("\t-H               -   search for files using FTP on the given <host>");
        System.err.println("\t-p               -   include directory parts in search, and display");
        System.err.println("\t-R               -   does not recurse. (recursive search is the default)");
        System.err.println("\t-s               -   succinct; shows only the path");
        System.err.println("\t<pattern>        -   search pattern, e.g. \"*.cpp\" (default is to search for all files)");
        System.err.println("\t<root-dir>       -   root directory of search; default is current working directory");

        System.exit(1);
    }

	private static void run_unittests()
	{
/*
		System.out.println("combine: " + FileSearch.combinePaths("abc", "def"));

		System.out.println("squeeze: " + FileSearch.squeezePath(FileSearch.stat(".").getPath(), 12));
*/
	}
}

/* ////////////////////////////////////////////////////////////////////// */
